unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Samples.Spin,
  Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.Imaging.pngimage, Vcl.Samples.Gauges,

  uciaxml;

type
  TForm1 = class(TForm)
    Panel_Main_Holder: TPanel;
    Button_Start: TButton;
    ProgressBar1: TProgressBar;
    SpinEdit_Stunde: TSpinEdit;
    SpinEdit_Minute: TSpinEdit;
    Panel2: TPanel;
    Panel3: TPanel;
    Button_Stop: TButton;
    Panel5: TPanel;
    Timer1: TTimer;
    Panel_Status: TPanel;
    Image1: TImage;
    CheckBox_MitAbfrage: TCheckBox;
    RadioGroup_ShutDownVariante_ShutDown: TRadioButton;
    RadioGroup_ShutDownVariante_Hibernate: TRadioButton;
    Button_Minimize: TButton;
    Button_Close: TButton;
    Panel1: TPanel;
    Button_About: TButton;
    procedure Button_CloseClick(Sender: TObject);
    procedure Button_MinimizeClick(Sender: TObject);
    procedure Button_StartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button_StopClick(Sender: TObject);
    procedure Panel5MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpinEdit_MinuteChange(Sender: TObject);
    procedure Button_AboutClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function DoSetup(Setup_Pfad, Setup_File: string; Lesen: Boolean = True): Boolean;
    procedure CheckSeiten;
  end;

var
  Form1: TForm1;

implementation

var
  cooldownTag, cooldownStunde, cooldownMinute, cooldownSekunde: Integer;
  cooldown_isrunning: Boolean = false;
  IsHibernate: Boolean = false;
  IsStandBy: Boolean = false;

{$R *.dfm}


function TForm1.DoSetup(Setup_Pfad, Setup_File: string;
  Lesen: Boolean = True): Boolean;
var
  Dummy_Setup: TXMLConfig;
begin

  Result := True;

  try
    Dummy_Setup := TXMLConfig.Create(Setup_Pfad + Setup_File);
    Dummy_Setup.Backup := false;

    case Lesen of

      True: { Setup lesen }
        with Dummy_Setup do
        begin

          { Fensterposition auslesen }
          Form1.Left := ReadInteger('General', 'Left', 10);
          Form1.Top := ReadInteger('General', 'Top', 10);
          Form1.CheckBox_MitAbfrage.Checked :=
            ReadBoolean('General', 'CheckBox_MitAbfrage', false);
          Form1.RadioGroup_ShutDownVariante_ShutDown.Checked :=
            ReadBoolean('General',
            'RadioGroup_ShutDownVariante_ShutDown', True);
          Form1.RadioGroup_ShutDownVariante_Hibernate.Checked :=
            ReadBoolean('General',
            'RadioGroup_ShutDownVariante_Hibernate', false);
          Form1.SpinEdit_Stunde.Value :=
            ReadInteger('General', 'SpinEdit_Stunde', 0);
          Form1.SpinEdit_Minute.Value :=
            ReadInteger('General', 'SpinEdit_Minute', 0);

        end;
      false: { Setup schreiben }
        with Dummy_Setup do
        begin

          { Fensterposition auslesen }
          WriteInteger('General', 'Left', Form1.Left);
          WriteInteger('General', 'Top', Form1.Top);
          WriteBoolean('General', 'CheckBox_MitAbfrage',
            Form1.CheckBox_MitAbfrage.Checked);
          WriteBoolean('General', 'RadioGroup_ShutDownVariante_ShutDown',
            Form1.RadioGroup_ShutDownVariante_ShutDown.Checked);
          WriteBoolean('General', 'RadioGroup_ShutDownVariante_Hibernate',
            Form1.RadioGroup_ShutDownVariante_Hibernate.Checked);
          WriteInteger('General', 'SpinEdit_Stunde',
            Form1.SpinEdit_Stunde.Value);
          WriteInteger('General', 'SpinEdit_Minute',
            Form1.SpinEdit_Minute.Value);

          Dummy_Setup.Save;

        end;

    end;
  finally

  end;
end;

procedure TForm1.CheckSeiten;
begin

  if Self.Left + Self.Width < Screen.MonitorFromWindow(Self.Handle).WorkareaRect.Left + 64 then
    Self.Left := 64 - Self.Width;

  if Self.Left + 64 > Screen.DesktopWidth then
    Self.Left := Screen.DesktopWidth - 64;

  if Self.Top + Self.Height < Screen.MonitorFromWindow(Self.Handle).WorkareaRect.Top + 64 then
    Self.Top := 64 - Self.Height;

  if Self.Top + 64 > Screen.MonitorFromWindow(Self.Handle).WorkareaRect.Height then
    Self.Top := Screen.MonitorFromWindow(Self.Handle).WorkareaRect.Height - 64;

end;

function HibernateAllowed: Boolean;
type
  TIsPwrHibernateAllowed = function: Boolean; stdcall;
var
  hPowrprof: HMODULE;
  IsPwrHibernateAllowed: TIsPwrHibernateAllowed;
begin
  Result := false;
  if Win32Platform <> VER_PLATFORM_WIN32_NT then
    Exit;
  hPowrprof := LoadLibrary('powrprof.dll');
  if hPowrprof <> 0 then
  begin
    try
      @IsPwrHibernateAllowed := GetProcAddress(hPowrprof,
        'IsPwrHibernateAllowed');
      if @IsPwrHibernateAllowed <> nil then
      begin
        Result := IsPwrHibernateAllowed;
      end;
    finally
      FreeLibrary(hPowrprof);
    end;
  end;
end;

function MyExitWindows(RebootParam: Longword): Boolean;
var
  TTokenHd: THandle;
  TTokenPvg: TTokenPrivileges;
  cbtpPrevious: DWORD;
  rTTokenPvg: TTokenPrivileges;
  pcbtpPreviousRequired: DWORD;
  tpResult: Boolean;
const
  SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';
begin
  if Win32Platform = VER_PLATFORM_WIN32_NT then
  begin
    tpResult := OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES or
      TOKEN_QUERY, TTokenHd);
    if tpResult then
    begin
      tpResult := LookupPrivilegeValue(nil, SE_SHUTDOWN_NAME,
        TTokenPvg.Privileges[0].Luid);
      TTokenPvg.PrivilegeCount := 1;
      TTokenPvg.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      cbtpPrevious := SizeOf(rTTokenPvg);
      pcbtpPreviousRequired := 0;
      if tpResult then
        Winapi.Windows.AdjustTokenPrivileges(TTokenHd, false, TTokenPvg,
          cbtpPrevious, rTTokenPvg, pcbtpPreviousRequired);
    end;
  end;
  Result := ExitWindowsEx(RebootParam, 0);
end;

function IsWinNT: Boolean;
var
  OSVersion: TOSVersionInfo;
begin
  Result := false;
  OSVersion.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  if GetVersionEx(OSVersion) then
    Result := (OSVersion.dwPlatformId = VER_PLATFORM_WIN32_NT);
end;

procedure CheckSystemPowerState;
type
  TIsCheckFkt = function: Boolean; stdcall;
var
  hDll: THandle;
  IsCheckFkt: TIsCheckFkt;
begin
  hDll := LoadLibrary('PowrProf.dll');
  if hDll <> 0 then
  begin
    @IsCheckFkt := GetProcAddress(hDll, 'IsPwrHibernateAllowed');
    if assigned(IsCheckFkt) then
      IsHibernate := IsCheckFkt;
    @IsCheckFkt := GetProcAddress(hDll, 'IsPwrSuspendAllowed');
    if assigned(IsCheckFkt) then
      IsStandBy := IsCheckFkt;
  end;
end;

procedure SetStandBy(SetStandBy: Boolean);
var
  TokenPriv: TTokenPrivileges;
  TokenHandle: THandle;
  CurrentProc: THandle;
  Len: Cardinal;
begin
  CheckSystemPowerState;

  // WinNT, 2000, XP need the SE_SHUTDOWN_NAME privilege
  if IsWinNT then
  begin
    // determine the actual Process
    CurrentProc := GetCurrentProcess;

    // get process token for privileges
    if OpenProcessToken(CurrentProc, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,
      TokenHandle) then
    begin
      // returns the system-id of the privilege
      if LookupPrivilegeValue(nil, 'SeShutdownPrivilege',
        TokenPriv.Privileges[0].Luid) then
      begin
        TokenPriv.PrivilegeCount := 1;
        TokenPriv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;

        // here y try to get the privilege
        if AdjustTokenPrivileges(TokenHandle, false, TokenPriv, 0, nil, Len)
        then
        begin
          if (SetStandBy = false) and IsHibernate then
            // and then y can got to StandBy or Hibernate
            // (first parameter = True => StandBy, False => Hibernate)
            SetSystemPowerState(SetStandBy, false);
          if SetStandBy and IsStandBy then
            // and then y can got to StandBy or Hibernate
            // (first parameter = True => StandBy, False => Hibernate)
            SetSystemPowerState(SetStandBy, false);
        end;
      end;
    end;
  end
  else if IsStandBy then
    // Win95/98/Me dont need Privileges and dont support hibernating
    SetSystemPowerState(false, false);
end;

procedure TForm1.Button_StartClick(Sender: TObject);
begin

  cooldownTag := SpinEdit_Stunde.Value div 24;
  if cooldownTag > 0 then
    cooldownStunde := SpinEdit_Stunde.Value mod 24
  else
    cooldownStunde := SpinEdit_Stunde.Value;
  cooldownMinute := SpinEdit_Minute.Value;
  cooldownSekunde := 0;

  ProgressBar1.Max := (cooldownTag * (24 * 3600)) + (cooldownStunde * 3600) +
    (cooldownMinute * 60);
  ProgressBar1.Position := ProgressBar1.Max;
  Timer1.Interval := 1000;
  Timer1.Enabled := True;
  Button_Start.Enabled := false;
  Button_Stop.Enabled := True;
  Button_Stop.SetFocus;

end;

procedure TForm1.Button_AboutClick(Sender: TObject);
begin
  ShowMessage('ShutDown Tool by TRM 2024 (www.nogad.de)');
end;

procedure TForm1.Button_CloseClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button_MinimizeClick(Sender: TObject);
begin
  Self.WindowState := wsMinimized;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
begin
  Timer1.Enabled := false;
  Button_Start.Enabled := True;
  Button_Stop.Enabled := false;
  Button_Start.SetFocus;
  ProgressBar1.Position := ProgressBar1.Min;
  Panel_Status.Caption := 'Status..';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  DoSetup(ExtractfilePath(application.ExeName), 'setup_shutdown.trm', false);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  { Programm anpassen }

  application.Title := Panel1.Caption;
  Self.Caption := Panel1.Caption;
  Panel_Main_Holder.Left := 0;
  Panel_Main_Holder.Top := 0;

  SetBounds(Left, Top, Panel_Main_Holder.Width, Panel_Main_Holder.Height);
  Panel_Main_Holder.Align := alClient;
  Self.Borderstyle := bsNone;
  { Programm anpassen }

  Button_Stop.Enabled := false;

  DoSetup(ExtractfilePath(application.ExeName), 'setup_shutdown.trm', True);
  if not HibernateAllowed then
  begin
    RadioGroup_ShutDownVariante_Hibernate.Enabled := false;
    RadioGroup_ShutDownVariante_Hibernate.Checked := false;
  end;
  cooldownTag := 0;
  cooldownStunde := 0;
  cooldownMinute := 0;
  cooldownSekunde := 0;

  CheckSeiten;

end;

procedure TForm1.Panel5MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin

  if not(ssLeft in Shift) then
    Exit;
  ReleaseCapture;
  Perform(wm_syscommand, $F012, 0);

  CheckSeiten;
end;

procedure TForm1.SpinEdit_MinuteChange(Sender: TObject);
begin

  SpinEdit_Minute.OnChange := nil;
  SpinEdit_Stunde.OnChange := nil;

  if SpinEdit_Minute.Value > 59 then
  begin
    SpinEdit_Minute.Value := 0;
    SpinEdit_Stunde.Value := SpinEdit_Stunde.Value + 1;
  end;

  if SpinEdit_Minute.Value < 0 then
  begin
    if SpinEdit_Stunde.Value <= 0 then
    begin
      SpinEdit_Minute.Value := 0;
    end;
    if SpinEdit_Stunde.Value > 0 then
    begin
      SpinEdit_Stunde.Value := SpinEdit_Stunde.Value - 1;
      SpinEdit_Minute.Value := 59;
    end;
  end;

  if SpinEdit_Stunde.Value < 0 then
  begin
    SpinEdit_Stunde.Value := 0;
  end;

  SpinEdit_Minute.OnChange := SpinEdit_MinuteChange;
  SpinEdit_Stunde.OnChange := SpinEdit_MinuteChange;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  str: string;
  doExit: Boolean;
begin

  if cooldown_isrunning then
    Exit;

  cooldown_isrunning := True;

  if cooldownSekunde < 0 then
  begin
    dec(cooldownMinute);
    cooldownSekunde := 59;

    if cooldownMinute < 0 then
    begin
      dec(cooldownStunde);
      cooldownMinute := 59;

      if cooldownStunde < 0 then
      begin
        dec(cooldownTag);
        cooldownStunde := 23;

        if cooldownTag < 0 then
        begin
          Button_StopClick(nil);
          Timer1.Enabled := false;
          doExit := True;
          if CheckBox_MitAbfrage.Checked then
          begin
            if RadioGroup_ShutDownVariante_ShutDown.Checked then
              doExit := MessageBox(Handle, 'Diesen PC jetzt ausschalten?',
                'Besttigen', MB_YESNO) = IDYES
            else if RadioGroup_ShutDownVariante_Hibernate.Checked then
              doExit := MessageBox(Handle,
                'Diesen PC jetzt in den Ruhezustand versetzen?', 'Besttigen',
                MB_YESNO) = IDYES;
          end;
          if doExit then
          begin
            if RadioGroup_ShutDownVariante_ShutDown.Checked then
              MyExitWindows(EWX_POWEROFF or EWX_FORCE)
            else if RadioGroup_ShutDownVariante_Hibernate.Checked then
              SetStandBy(false);
          end;
          Exit;
        end;

      end;

    end;

  end;

  if cooldownTag > 0 then
    str := format('Tage: %d .. Sekunden: %2.2d', [cooldownTag, cooldownSekunde])
  else if cooldownStunde > 0 then
    str := format('Stunden: %d .. Sekunden: %2.2d',
      [cooldownStunde, cooldownSekunde])
  else if cooldownMinute > 0 then
    str := format('%2.2d:%2.2d ', [cooldownMinute, cooldownSekunde])
  else if cooldownSekunde > 0 then
    str := format('%d', [cooldownSekunde]);

  // str := format('D: %d / %2.2d:%2.2d:%2.2d', [cooldownTag, cooldownStunde, cooldownMinute, cooldownSekunde]);

  Panel_Status.Caption := str;

  dec(cooldownSekunde);
  ProgressBar1.StepBy(-1);

  cooldown_isrunning := false;

end;

end.
